/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operate_OperatorState_h__
#define __operate_OperatorState_h__

namespace fe
{

/**************************************************************************//**
	@brief Operator base class to save and reload state

	@ingroup operate
*//***************************************************************************/
class FE_DL_EXPORT OperatorState:
	virtual public OperatorSurfaceCommon,
	public Initialize<OperatorState>
{
	public:

							OperatorState(void)								{}
virtual						~OperatorState(void)							{}

		void				initialize(void);

							//* As OperatorSurfaceI
virtual	BWORD				saveState(String& rBuffer);
virtual	BWORD				loadState(const String& rBuffer);

	protected:

virtual	void				setupState(void)								{}

		sp<Scope>			m_spScope;
		sp<RecordGroup>		m_spState;
};

} /* namespace */

#endif /* __operate_OperatorState_h__ */
