/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_FollicleOp_h__
#define __operator_FollicleOp_h__

namespace fe
{

/**************************************************************************//**
	@brief Operator to edit surface locations

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT FollicleOp:
	public OperatorState,
	public Initialize<FollicleOp>
{
	public:

						FollicleOp(void):
							m_brushed(FALSE)								{}

virtual					~FollicleOp(void)									{}

		void			initialize(void);

						//* As HandlerI
virtual	void			handle(Record& a_rSignal);

	protected:

void					drawFollicle(sp<DrawI>& a_rspDraw,
								const SpatialVector& a_rPoint,
								Real a_rimSize,const Color& a_rColor);

		Record			getEdit(I32 a_index);
		void			movePicked(const SpatialVector& a_rDelta);
		void			snapToSurface(I32 a_index);

		BWORD			pickToggle(I32 a_index);
		BWORD			picked(I32 a_index);

virtual	void			setupState(void);
virtual	BWORD			loadState(const String& rBuffer);

	private:
		sp<SurfaceAccessorI>		m_spInputPoint;
		sp<SurfaceAccessorI>		m_spOutputPoint;
		sp<SurfaceAccessorI>		m_spOutputNormal;
		sp<SurfaceI>				m_spDriver;
		WindowEvent					m_event;

		sp<DrawMode>				m_spWireframe;
		sp<DrawMode>				m_spSolid;

		sp< RecordMap<I32> >		m_spEditMap;
		Accessor<I32>				m_aIndex;
		Accessor<SpatialVector>		m_aLocation;

		BWORD						m_brushed;
		I32							m_lastX;
		I32							m_lastY;

		std::vector<Color>			m_colorArray;
		std::vector<I32>			m_pickArray;
};

} /* namespace */

#endif /* __operator_FollicleOp_h__ */
