/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "surface.pmh"

namespace fe
{

SurfaceCurves::SurfaceCurves(void)
{
	feLog("SurfaceCurves::SurfaceCurves\n");
}

Protectable* SurfaceCurves::clone(Protectable* pInstance)
{
	feLog("SurfaceCurves::clone\n");

	SurfaceCurves* pSurfaceCurve= pInstance?
			dynamic_cast<SurfaceCurves*>(pInstance): new SurfaceCurves();

	checkCache();

	//* TODO

	return pSurfaceCurve;
}

void SurfaceCurves::cache(void)
{
	if(!m_record.isValid())
	{
		feLog("SurfaceCurves::cache record invalid\n");
		return;
	}

	SurfaceSphere::cache();

	//* TODO

	SurfaceModel surfaceModelRV;
	surfaceModelRV.bind(m_record);

	sp<RecordGroup> spRG=surfaceModelRV.surfacePointRG();
	for(RecordGroup::iterator it=spRG->begin();it!=spRG->end();it++)
	{
		sp<RecordArray> spRA= *it;

		SurfacePoint m_surfacePointRV;
		m_surfacePointRV.bind(spRA);
		while(m_surfacePointRV.step())
		{
			SpatialVector& location=m_surfacePointRV.location();
			SpatialVector& up=m_surfacePointRV.up();

			m_pVertexArray=(SpatialVector*)reallocate(m_pVertexArray,
					(m_vertices+1)*sizeof(SpatialVector));

			SpatialVector& rVertex=m_pVertexArray[m_vertices];

			rVertex=location;

			printf("vertex %d  %s\n",m_vertices,c_print(rVertex));
			m_vertices++;
		}
	}
}

SpatialTransform SurfaceCurves::sample(Vector2 a_uv) const
{
	SpatialTransform transform;

	//* TODO
	setIdentity(transform);

	return transform;
}

void SurfaceCurves::draw(const SpatialTransform& a_transform,
	sp<DrawI> a_spDrawI,const Color* color) const
{
	//* TODO
}

} // namespace
